#!/usr/bin/env python
# -*- coding: utf8 -*-

import sqlite3
import random
import os

db_path = "/var/www/cyber_generator/de_DE.sqlite"

try:
	db_connection = sqlite3.connect(db_path)
	db_cursor = db_connection.cursor()
except sqlite3.OperationalError:
	html = u"""
<!DOCTYPE HTML>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Internal server error!</title>
</head>
<body>
<h1>Error: Could not connect to database!</h1>
</body>
</html>"""
	status = "503 Internal server error"
	print "Database connection could not be established!"
else:
	num_words = db_cursor.execute("SELECT COUNT(*) FROM wordlist")
	num_words = int(num_words.fetchall()[0][0])
	html = u"""
<!DOCTYPE HTML>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>cyber-everything.de: Der ultimative Cyber-Generator!</title>
<body>
<h1 style="text-align:left;">Cyber-Generator</h1>
<nav><ul style="padding:0"><li style="display:inline;padding:5px;"><a href="#word">Wort</a></li>
<li style="display:inline;padding:5px;"><a href="#cyber">Cyber?</a></li>
<li style="display:inline;padding:5px;"><a href="#disclaimer">Disclaimer</a></li>
<li style="display:inline;padding:5px;"><a href="/impressum">Impressum</a></li></ul></nav>
<div style="text-align:center;font-size:large;" id="word">Das Cyber-Wort der Sekunde:</div>
<div style="font-size:xx-large;font-family:sans-serif;text-align:center;padding-top:15px;padding-bottom:10px;color:#FA5882;">Cyber-%s</div>
<div style="text-align:right;font-size:small">Dieses Ergebnis wurde bereits %s Mal generiert</p>
<hr>
<h2 style="padding-top:20px;text-align:left;" id="cyber">Cyber?</h2>
<div style="text-align:left;font-size:medium;">
Das Wort bzw. besser das Präfix Cyber stammt laut <a href="http://de.wikipedia.org/wiki/Cyber">Wikipedia</a> aus dem Altgriechischen, bedeutet "Steuerung" und bezog sich ursprünglich auf die Seefahrt. Irgendwann wurde dieser Präfix dann mit der Computertechnik in Verbindung gebracht und dürfte den meisten zumindest durch den seit längerem etablierten Begriff "Cyberspace" bekannt sein. Eben diese Assoziation mit Computer- bzw. Netzwerktechnik haben sich in letzter Zeit viele Personen - vor allem Politiker aus Regierung und Opposition - zunutze gemacht, um dieses Präfix allen möglichen Wörtern voranzustellen, die irgendwie in diesen Themenbereich zu passen scheinen. Entstanden sind dabei Stilblüten wie ein "Cyber-Abwehrzentrum", "Cyber-Sicherheit", "Cyber-Kriminelle", eine "Cyber-Strategie" und viele Weitere.</div>

<div style="text-align:left;font-size:medium;">
 Wie man sicherlich merkt, klingt diese Wortzusammensetzung einerseits modern, führt aber andererseits auch zu einem Bedeutungsverlust. Im Endeffekt weiß der Sprecher, wovon er spricht, der Höhrer kann sich aber alles Mögliche darunter vorstellen, irgendetwas mit Computern und Internet wird es schon zu tun haben. Aus diesem Grund gibt es hier jetzt den ultimativen Cyber-Generator, mit dem sich Jeder in der Art einer Phrasen-Dreschmaschine ein zufälliges Wort bestehend aus dem Präfix "Cyber" und einem deutschen Substantiv generieren lassen kann. Ein Sinn-Zusammenhang kann dabei natürlich nicht garantiert, gerne aber hereininterpretiert werden (das muss dann die "Cyber-Interpretation" sein oder so). Ein weiteres Wort gefällig? Lade einfach die Seite neu!
</div>
<h2 style="padding-top:20px;text-align:left;" id="disclaimer">Disclaimer</h2>
<div style="text-align:left;font-size:medium;">
Wie bereits erwähnt, wird bei jedem Aufruf dieser Seite ein zufälliges Wort auf Basis einer Datenbank mit Substantiven der deutschen Sprache generiert. Diese Datenbank ist nicht gefiltert und enthält daher auch alle weniger schönen Substantive, daher auch solche, die von einzelnen Personen als diskriminierend, beleidigend oder sonst irgendwie anstößig empfunden werden könnten. Ich bitte daher darum, das Ergebnis als das zu betrachten, was es ist: Ein zufälliges Ergebnis, produziert von gefühlslosem Code. Ich übernehme ausdrücklich keine Verantwortung für erschütterte Weltbilder, blankes Entsetzen oder sonstige negative Reaktionen auf möglicherweise nicht gefällige Resultate.</div>
</body>
</html>"""
	status = "200 OK"

class RandomWord(object):

	def __init__(self):
		"""Initializes the object, getting a random word and the number
		of times it has been picked before from the database.

		"""
		self.word_id = random.randint(2, num_words)
		self.__sqlword = "SELECT word,used FROM wordlist where id = ?"
		self.__query_result = db_cursor.execute(self.__sqlword, (self.word_id,))	
		self.__query_result = self.__query_result.fetchall()
		self.word = self.__query_result[0][0]
		self.used = self.__query_result[0][1]
	
	def update(self):
		"""Increments the number of uses of a word by one, writing it back to
		the database.	

		"""
		self.__new_used = self.used + 1
		self.__sqlupdate = "UPDATE wordlist SET used = ? WHERE id = ?"
		db_cursor.execute(self.__sqlupdate, (self.__new_used, self.word_id))
		db_connection.commit()

def application(environ, start_response):

	if status == "200 OK" :	
		new_word = RandomWord()
		response_body = html % (new_word.word, new_word.used)
		new_word.update()
	else:
		response_body = html

	response_headers = [('Content-Type', 'text/html'),
			('Content-Length', str(len(response_body.encode('utf8'))))]
	start_response(status, response_headers)
	return [response_body.encode('utf8')]

